﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	
	Public client As Object											' Client activity
	Public prefix As String											' Client's callback prefix
	
	Private MAC As String												' Currently connected device
	Private filename As String = "BTMgr.txt"		' Used to save latest MAC
	
	Private astream As AsyncStreams
	Private serial As Serial
	Private bt As BluetoothAdmin
	Private connected As Boolean = False
	
	Public devices As List
	
	
End Sub

Public Sub initialize
	bt.Initialize("bt")
	serial.Initialize("serial")
	If bt.IsEnabled = False Then
		If bt.Enable = False Then
			ToastMessageShow("Error enabling Bluetooth adapter.", True)
		End If
	End If
End Sub

' If previous device has been saved try to reconnect
Public Sub start
	If Not(connected) And File.Exists(File.DirInternal, filename) Then
		MAC = File.ReadString(File.DirInternal, filename)
		connectTo(MAC)
	End If
End Sub

' Pass status info to client callback routine
Private Sub status(msg As String, arg As Object)
	If (prefix.Length > 0) Then  CallSub3(client, prefix & "status", msg, arg)
End Sub

Public Sub connectTo(device As String)
	MAC = device															' Remember current device
	status("Connecting ...", True)
	serial.Connect(MAC)
	' Save most recent target MAC
	File.WriteString(File.DirInternal, filename, MAC)
End Sub

Public Sub disconnect
	If astream.IsInitialized Then astream.Close
	serial.Disconnect
End Sub

Public Sub searchForDevices As Boolean
	devices.Initialize
	Return bt.StartDiscovery
End Sub

Private Sub bt_StateChanged (NewState As Int, OldState As Int)
	Log("State changed: " & NewState)
End Sub

Private Sub bt_DiscoveryFinished
	CallSub(client, prefix & "discoveryFinished")
End Sub

Private Sub bt_DeviceFound(Name As String, MacAddress As String)
	Dim device As String = Name & "|" & MacAddress
	Log(device)
	devices.Add(device)
End Sub

Private Sub serial_Connected(Success As Boolean)
	If Success = False Then
		connected = False
		status("Connection failed", False)
		Log(LastException.Message)
	Else
		connected = True
		status("Connected", True)
		If astream.IsInitialized Then astream.Close
		astream.Initialize(serial.InputStream, serial.OutputStream, "astream")
	End If
End Sub

Public Sub sendBytes(msg() As Byte) As Boolean
	status("Data sent", True)
	Return astream.Write(msg)
End Sub

Public Sub sendASCII(msg As String) As Boolean
	Return sendBytes(msg.GetBytes("UTF8"))
End Sub

Private Sub aStream_NewData(Buffer() As Byte)
'	Log("NewData = " & BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
	CallSub2(client, prefix & "newData", Buffer)
End Sub

Private Sub aStream_Error
	status("Connection broken", False)
End Sub

Private Sub aStream_Terminated
	aStream_Error
End Sub